/*
 *  $Id: r.defs.h,v 2.5 2001/08/09 10:02:38 w Exp w $
 *
 *   RED.
 *
 *       RED
 *
 *  $Log: r.defs.h,v $
 *  Revision 2.5  2001/08/09 10:02:38  w
 *  Legacy restriction removed: 32767 lines maximum at writing
 *  editing result.
 *  Fixes for ANSI-fication, "-fwritable-strings -Wtraditional"
 *  options do not reqired anymore, and -Wall going well.
 *  Some fixes "0 vs. NULL" pointers.
 *  New undocumented feature: "arg: 0l rpl ..." work with
 *  whole file now.
 *  'register' type qualifyer on the way of removing.
 *  dumpfsd() fixed to be functional (enabled by -DDEBUG).
 *  [s]append(...,"") using improved a bit.
 *  dumpfsd() activation changed to ^X.
 *  Version numbering changed to major.minor.ext.build scheme.
 *
 *  Revision 2.4  1998/05/14 17:16:37  w
 *   redhat-4.2  termio.h  CEOF.
 *
 *  Revision 2.3  1998/05/13 18:34:30  w
 *  ANSI-     glibc  redhat-5.0.
 *       .
 *
 *  Revision 2.2  1997/06/12 23:15:29  w
 *    gt.
 *          -8,
 *     g_table (  ).
 *    .
 *      splitline(), openlines(). ( ""
 *      ).
 *    CSI (0233).
 *    cntrl- (  ,
 *    termio (BSD)):      (0377).
 *   /    ""   .
 *
 *  Revision 2.1  1997/06/02 18:47:53  w
 *     .
 *
 *  Revision 2.0  1997/05/30 18:33:56  w
 *  !!!
 *  Red   8- (control-   ).
 *         .
 *
 *  Revision 1.3  1997/05/20 11:14:11  w
 *  Extended window size (lines, rows).
 *
 *  Revision 1.2  1997/04/26 13:32:03  w
 *   
 *
 *  Revision 1.1  1997/04/26 09:48:37  w
 *  Initial revision
 *
 * Revision 4.20  90/05/22  23:21:26  alex
 * First rev. red 4.2
 * 
 * Revision 4.10  90/02/05  19:52:10  alex
 * Base revision 4.1
 * 
 * Revision 4.10  90/02/05  19:40:33  alex
 * Base revision 4.1
 * 
 * Revision 4.1  88/03/31  21:58:59  alex
 *  4.1 -   UTEC, 
 * 
 * Revision 3.1.2.5  87/07/03  22:00:43  alex
 * Graph_characters used in margin
 * 
 * Revision 3.1.2.4  87/06/29  17:54:21  alex
 * Commans set to 0200-0277
 * 
 * Revision 3.1.2.3  87/06/24  22:31:57  alex
 * New readch + gettc + tc table Tested
 * 
 * Revision 3.1.2.2  87/06/23  18:43:29  alex
 *   lread1   
 * 
 * Revision 3.1.2.1  87/06/19  16:58:36  alex
 * Start revision for red/4
 * 
 * Revision 3.11  87/06/12  18:09:23  alex
 *     vilcase    vt-200
 * 
 * Revision 3.10  87/06/09  19:46:04  alex
 *    tty ~ VT200  15--0013
 * 
 * Revision 3.9  87/06/06  16:48:40  alex
 *  roll    sr/sf  
 *     -t +  
 * 
 * Revision 3.8  87/06/05  23:49:32  alex
 *  roll    sr/sf  
 *     -t +  
 * 
 * Revision 3.7  87/06/04  23:42:53  alex
 * Scroll on -sr- or -al/dl- added
 * 
 * Revision 3.6  87/04/02  18:33:33  alex
 *   Utec       
 * 
 * Revision 3.5  87/04/01  19:15:01  alex
 * Revision for Utec: Cs, Ce, Ct, hR
 * 
 * Revision 3.4  86/09/19  19:46:39  alex
 *   -1700
 * 
 * Revision 3.3  86/08/04  20:49:12  alex
 *    /  2
 * 
 * Revision 3.2  86/07/24  00:20:10  alex
 * '      
 * 
 * Revision 3.1.1.6  86/07/15  22:09:24  alex
 * RED 3.3/EC.
 * 
 * Revision 3.1.1.5  86/06/19  00:09:04  alex
 *     
 * 
 * Revision 3.1.1.4  86/06/17  19:25:13  alex
 * .
 * 
 * Revision 3.1.1.3  86/06/16  22:14:49  alex
 *      ( )
 * 
 * Revision 3.1.1.2  86/06/09  22:25:18  alex
 * TTY OUTPUT IS TESTED
 * 
 * Revision 3.1.1.1  86/06/05  00:02:19  alex
 * __
 * 
 * Revision 3.1  86/04/20  23:39:22  alex
 *    .
 * 
 * Revision 3.1  86/04/20  23:39:22  alex
 *    .
 * 
 * Revision 3.1  86/04/20  23:39:22  alex
 * *** empty log message ***
 * 
 *      Revision 1.4  86/04/13  21:55:13  alex
 */

#ifndef DEBUG
#define WORK
#endif

#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

/*    ned.ddefs */
/*#include LOCL*/
#include "r.local.h"

#ifndef TTYDEF_SPEED
#define TTYDEF_SPEED  (B9600)
#endif

#ifndef MAXFILES
#define MAXFILES 14
#endif
#ifndef MAXPORTLIST
#define MAXPORTLIST 12
#endif

#ifdef RUSDIAG
#define DIAG(l,r) r
#else
#ifdef ALLDIAG
int latdiag;
#define DIAG(l,r) (latdiag ? l : r)
#else
#define DIAG(l,r) l
#endif
#endif

/*#ifdef WORK*/
#ifndef DEBUG
#define DEBUGCHECK /* */
#else
#define DEBUGCHECK checkfsd()   /* check fsd consistency for debugging */
#define FSDDUMP "_FSDDUMP"
#endif

/*--*
#undef NULL
#define NULL ((char *)0)
 *--*/
#define NIL ((char *) NULL)

#define EDITED 2       /*  openwrite,    */

#ifndef LINELM
#ifndef DEMOSES
#define LINELM 128          /* .     */
#define LBUFFER 256         /* ***    fsdmaxl  **** */
#else
#define LINELM 132          /* .     */
#define LBUFFER 512         /* ***    fsdmaxl  **** */
#endif
#endif

#ifndef NLINESM
#define NLINESM 48          /* .      */
#endif

#define NEWLINE     012     /* newline  */
#define PARAMREDIT  40      /*   paramport */
#define PARAMRINFO  74      /*      paramport */
#define PARAMRLANG  74      /*      */
#define PARAMRMAC   77      /*      */
#define NPARAMLINES 1       /*    PARAMPORT */
#define FILEMODE    0664    /*      */

#define FOREVER for (;;)
#define BADF    -1
#define CONTF   -2

/*-------------------- Character map -----------------------------------*
 |
 |         (    ).
 |
 |     2- ,     .
 |
 *-->>>-CM--------------------------------------------------------------*/

/*       1.  ,  dflplline,  */
#define PL1MOVEW    0x7fff
#define MI1MOVEW    0x7ffe

/*--------------------------------------
 *  
 *    
 */
#define ATRMASK     0x7000                  /*         */
#define NONATRMASK  0x0fff                  /*          */
#define ATR(x)      ((x & 07) << 12)        /*     */

/*--<<<-CM--------------------------------------------------------------*/

/*
 * 
 */
#define A_NORM  ATR(1)  /*  COANORMAL  */
#define A_INFO  ATR(2)  /*  COAINFO    */
#define A_ERROR ATR(3)  /*  COAERROR   */
#define A_MARG  ATR(4)  /*  COAMARG    */
#define A_OUT   ATR(5)  /*  COAOUT     */

/*    */
#define ISATR(c) ((c & ATRMASK) >= A_NORM && (c & ATRMASK) <= A_OUT)
#define A2CO(c) (((c & ATRMASK) >> 12) + COANORMAL - 1)  /*    */

int need_atr;       /*             */

/*--------------------------*
 |  .
 |      OUTPUT CODES
 *--------------------------*/
/*--    --*/
#define COMASK  0x1f                    /*    */

#ifndef DEMOSES

#define COSTART      0

#define COUP         1
#define CODN         2
#define CORN         3
#define COHO         4
#define CORT         5
#define COLT         6
#define COCURS       7
#define COBELL       8
#define COFIN        9
#define COERASE     10
#define COOPEN      11
#define COCLOSE     12
#define COVIOPE     13
#define COVICLO     14
#define COCYON      15
#define COCYOFF     16
#define COILINE     17
#define CODELIN     18
#define COSRFWD     19
#define COSRBAK     20
#define COCLLIN     21
#define COCLSCR     22

#define COANORMAL   23  /*  A_NORM     */
#define COAINFO     24  /*  A_INFO     */
#define COAERROR    25  /*  A_ERROR    */
#define COAMARG     26  /*  A_MARG     */
#define COAOUT      27  /*  A_OUT      */

#define COGSTART    28
#define COGEND      29

#define COMCOD      30      /*    */

#else   /* +DEMOSES */

#define COSTART      0
/*---*
#define COUP         1
#define CODN         2
#define CORN         3
 *---*/
# define COHO        4
/*---*
#define CORT         5
#define COLT         6
 *---*/
#define COCURS       7
#define COBELL       8
#define COFIN        9
#define COERASE     10

#define COMCOD      11 /*    */

#endif  /* +DEMOSES */

#define ISCOM(c)    ((c) >= COSTART && (c) < COMCOD)

#define COESC0  COCURS      /* 0x07 = 0007 =  7 */
#define C_SI    016         /* 0x0e = 0016 = 14 = CNTRL('n') */
#define C_SO    017         /* 0x0f = 0017 = 15 = CNTRL('o') */
#define ESC2    037         /* 0x1f = 0037 = 31 */
#define DQUOTA  '"'         /* 0x22 = 0042 = 34 */
#define QUOTA   '\''        /* 0x27 = 0047 = 39 */
#define ESC1    '\\'        /* 0x5c = 0134 = 92 */


/*
 *  :
 *        (CC*)
 */
#define VMOTCODE 4  /*  1 - 4      */
#define KB_UP       1   /* Up     */
#define KB_DN       2   /* Down   */
#define KB_RN       3   /* Return */
#define KB_HO       4   /* Home   */
#define KB_RT       5   /* Right  */
#define KB_LT       6   /* Left   */
#define KB_TB       7   /* Tab    */
#define KB_BT       8   /* Backtab*/

/*
 *  
 */
#define CC          0600    /*  .   red */
#define CC_CMD(c)   (CC + c)
#define ISACMD(c)   ((c & 0700) == CC)

#define CCQUIT          CC_CMD( 0)  /* terminate editor run */

#define CCMOVEUP        CC_CMD(KB_UP)   /* move up 1 lin        */
#define CCMOVEDOWN      CC_CMD(KB_DN)   /* move down 1 line     */
#define CCRETURN        CC_CMD(KB_RN)   /* return               */
#define CCHOME          CC_CMD(KB_HO)   /* home cursor          */
#define CCMOVERIGHT     CC_CMD(KB_RT)   /* forward move         */
#define CCMOVELEFT      CC_CMD(KB_LT)   /* backward move        */
#define CCTAB           CC_CMD(KB_TB)   /* tab                  */
#define CCBACKTAB       CC_CMD(KB_BT)   /* tab left             */

#define CCGOTO          CC_CMD(011)     /* goto linenumber      */
#define CCPLPAGE        CC_CMD(012)     /* minus a page         */
#define CCMIPAGE        CC_CMD(013)     /* plus a page          */
#define CCPLLINE        CC_CMD(014)     /* minus a line         */
#define CCMILINE        CC_CMD(015)     /* plus a line          */
#define CCLPORT         CC_CMD(016)     /* port left            */
#define CCRPORT         CC_CMD(017)     /* port right           */
#define CCPLSRCH        CC_CMD(020)     /* plus search          */
#define CCMISRCH        CC_CMD(021)     /* minus search         */
#define CCTABS          CC_CMD(022)     /* set tabs             */
#define CCINSERT        CC_CMD(023)     /* insert mode          */
#define CCINSMODE       CC_CMD(024)     /* insert mode          */
#define CCCHPORT        CC_CMD(025)     /* change port          */
#define CCOPEN          CC_CMD(026)     /* insert               */
#define CCCLOSE         CC_CMD(027)     /* delete               */
#define CCPUT           CC_CMD(030)     /* put                  */
#define CCPICK          CC_CMD(031)     /* pick                 */
#define CCDELCH         CC_CMD(032)     /* character delete     */
#define CCBACKSPACE     CC_CMD(033)     /* backspace and erase  */
#define CCCTRLQUOTE     CC_CMD(034)     /* knockdown next char  */
#define CCTRUNCATE      CC_CMD(035)     /*  (   lineop) */
#define CCENTER         CC_CMD(036)     /* enter parameter      */
#define CCRESCREEN      CC_CMD(037)     /*  */
#define CCSETFILE       CC_CMD(040)     /* set file             */
#define CCMAKEPORT      CC_CMD(041)     /* make a viewport      */
#define CCSAVEFILE      CC_CMD(042)     /* make new file        */
#define CCDOCMD         CC_CMD(043)     /* execute a filter     */
#define CCHELP          CC_CMD(044)     /* Help!                */
#define CCDEFMACRO      CC_CMD(045)     /* Define Macro - '0'   */
#define CCSAVEMACRO     CC_CMD(046)     /* Save Macro           */
#define CCREADMACRO     CC_CMD(047)     /* Read Macro           */
#define CCZOOMPORT      CC_CMD(050)     /* ZOOM / UNZOOM Window */
#define CCBEGIN         CC_CMD(051)     /* Cursor Begin         */
#define CCEND           CC_CMD(052)     /* Cursor End           */
#define CCPSEARCH       CC_CMD(053)     /* Parent Search        */
#define CCWORDLEFT      CC_CMD(054)     /* Word Left            */
#define CCWORDRIGHT     CC_CMD(055)     /*         */
#define CCWORDSELECT    CC_CMD(056)     /*         */
#define CCWORDGET       CC_CMD(057)     /*    PARAM  */
#define CCUNDO          CC_CMD(060)     /*    */
#define CCLINEJOIN      CC_CMD(061)     /*           */
#define CCLINESPLIT     CC_CMD(062)     /*     */
#define CCSELECT        CC_CMD(063)     /* /   */
#define CCDRAWMODE      CC_CMD(064)     /*     */

#ifdef DEMOSES
#define CCELINE         CC_CMD(070)     /* oe oca cpo */
#define CCILINE         CC_CMD(071)     /* aao oca cpo */
#define CCICURSOR       CC_CMD(072)     /* ac oo. ypcopa */
#endif

#define CCINTRUP        CC_CMD(077)     /* interuption (for ttyfile) */

/*------------------
 *   
 */
#define CCMAC             1     /* macro marka         */
				/* 2 == $a, 27 == $z   */
#define CCLASTMACRO       28    /* $0 -   */
#define CCMACWORD         29    /* $1 -          */
#define CCMACINIT         30    /* $2 -     */

#define CCEMAC            31    /*    */

#define ISMACRO(c)  ((c) > CCMAC && (c) <= CCEMAC)
#define ADD_MACRO(c) ((c != CCQUIT && c != CCDEFMACRO && M_p < M_e )\
		      ? (*M_p++ = c)\
		      : MacExpand(c))

/*---------------------
 *  
 */
#define G_START 0700
#define G_CHAR(c)   (G_START + c)
#define G_INDX(c)   (c - G_START)

/*-- "g1" -   --*/
#define G_GH    G_CHAR(000)  /* 01                    */
#define G_GV    G_CHAR(001)  /* 02 .                   */
#define G_LD    G_CHAR(002)  /* 03 BL  (    )    */
#define G_MD    G_CHAR(003)  /* 04 BM  ( T           )    */
#define G_RD    G_CHAR(004)  /* 05 BR  (   )    */
#define G_LM    G_CHAR(005)  /* 06 ML  ( T            )    */
#define G_CC    G_CHAR(006)  /* 07 CC  (              )    */
#define G_RM    G_CHAR(007)  /* 10 MR  ( T           )    */
#define G_LU    G_CHAR(010)  /* 11 TL  (   )    */
#define G_MU    G_CHAR(011)  /* 12 TM  ( T          )    */
#define G_RU    G_CHAR(012)  /* 13 TR  (  )    */

/*-- "g2" -   --*/
#define G_DGH   G_CHAR(013)  /* 14                    */
#define G_DGV   G_CHAR(014)  /* 15 .                   */
#define G_DLD   G_CHAR(015)  /* 16 BL  (    )    */
#define G_DMD   G_CHAR(016)  /* 17 BM  ( T           )    */
#define G_DRD   G_CHAR(017)  /* 20 BR  (   )    */
#define G_DLM   G_CHAR(020)  /* 21 ML  ( T            )    */
#define G_DCC   G_CHAR(021)  /* 22 CC  (              )    */
#define G_DRM   G_CHAR(022)  /* 23 MR  ( T           )    */
#define G_DLU   G_CHAR(023)  /* 24 TL  (   )    */
#define G_DMU   G_CHAR(024)  /* 25 TM  ( T          )    */
#define G_DRU   G_CHAR(025)  /* 26 TR  (  )    */

/*-- "g3" -  ,   --*/
#define G_DHGH  G_CHAR(026)  /* 27                    */
#define G_DHGV  G_CHAR(027)  /* 30 .                   */
#define G_DHLD  G_CHAR(030)  /* 31 BL  (    )    */
#define G_DHMD  G_CHAR(031)  /* 32 BM  ( T           )    */
#define G_DHRD  G_CHAR(032)  /* 33 BR  (   )    */
#define G_DHLM  G_CHAR(033)  /* 34 ML  ( T            )    */
#define G_DHCC  G_CHAR(034)  /* 35 CC  (              )    */
#define G_DHRM  G_CHAR(035)  /* 36 MR  ( T           )    */
#define G_DHLU  G_CHAR(036)  /* 37 TL  (   )    */
#define G_DHMU  G_CHAR(037)  /* 40 TM  ( T          )    */
#define G_DHRU  G_CHAR(040)  /* 41 TR  (  )    */

/*-- "g4" -  ,   --*/
#define G_DVGH  G_CHAR(041)  /* 42                    */
#define G_DVGV  G_CHAR(042)  /* 43 .                   */
#define G_DVLD  G_CHAR(043)  /* 44 BL  (    )    */
#define G_DVMD  G_CHAR(044)  /* 45 BM  ( T           )    */
#define G_DVRD  G_CHAR(045)  /* 46 BR  (   )    */
#define G_DVLM  G_CHAR(046)  /* 47 ML  ( T            )    */
#define G_DVCC  G_CHAR(047)  /* 50 CC  (              )    */
#define G_DVRM  G_CHAR(050)  /* 51 MR  ( T           )    */
#define G_DVLU  G_CHAR(051)  /* 52 TL  (   )    */
#define G_DVMU  G_CHAR(052)  /* 53 TM  ( T          )    */
#define G_DVRU  G_CHAR(053)  /* 54 TR  (  )    */

/*-- "g5" -    --*/
#define G_KR    G_CHAR(054)  /* 01   (    ) */
#define G_KL    G_CHAR(055)  /* 02    (     ) */
#define G_KU    G_CHAR(056)  /* 03    (             ) */
#define G_KD    G_CHAR(057)  /* 04     (            ) */
#define G_KRL   G_CHAR(060)  /* 05  <-->                 */
#define G_KUD   G_CHAR(061)  /* 06  -           */
#define G_TRR   G_CHAR(064)  /* 07             */
#define G_TRL   G_CHAR(065)  /* 10              */
#define G_TRU   G_CHAR(066)  /* 11              */
#define G_TRD   G_CHAR(067)  /* 12               */

/*-- "g6" -  ( ) --*/
#define G_SQU   G_CHAR(070)  /* 01       */
#define G_SQD   G_CHAR(071)  /* 02        */
#define G_SQL   G_CHAR(072)  /* 03         */
#define G_SQR   G_CHAR(073)  /* 04        */
#define G_SQ    G_CHAR(074)  /* 05      */
#define G_SQH   G_CHAR(075)  /* 06            */
#define G_RIP   G_CHAR(076)  /* 07  RIP               */

#define G_END   G_RIP

#define ISGCHAR(c)  ((c) >= G_START && (c) <= G_END)

/*--    --*/

#define G_GF    G_SQ         /*               */

/* Margin characters  (. B_MARG(col) ,  . ) */
#define LMCH    G_GV    /* Left margin of port character                */
#define RMCH    G_GV    /* Right margin of port                         */
#define TMCH    G_GH    /* Top margin of port                           */
#define BMCH    G_GH    /* Bottom margin of port                        */

#define LUCOR   G_LU    /* Upper left corner of port                    */
#define RUCOR   G_RU    /* Upper right corner of port                   */
#define LDCOR   G_LD    /* Down left corner of port                     */
#define RDCOR   G_RD    /* Down right corner of port                    */
#define DLMAR   G_LM    /* Left dubble corner of port (  ) */
#define DRMAR   G_RM    /* Right dubble corner of port (  ) */

#define BMTCH   G_KU    /* BMCH    ( +T)            */
#define MRMCH   G_KR    /* Modifyed right margin (  )    */
#define MLMCH   G_KL    /* Modifyed left margin (  )      */
#define BLMCH   G_KD    /* Blank line left margin ( )       */

#define DOTCH   G_GF    /* ????                                         */
#define AMCH    G_KU    /* Auto-indent margin ( ) */

#undef  GTABLEMAP       /* Full graphics charset                    */
#define GTABLEMAP       /* Restricted (g_table[]) graphics charset  */

/*----------------------------------------------------------------------*
 *      struct fsd -
 *   .   1  127  ,
 *  .     
 *----------------------------------------------------------------------*/
#ifdef UN_CHAR
typedef short schar;
#else
typedef char schar;
#endif

#define FSDMAXL 127     /* .    fsd */

struct fsd {
    struct fsd *backptr;    /*   . fsd   */
    struct fsd *fwdptr;     /*   . fsd   */
    char fsdnlines;         /*  ,   fsd */
			    /* 0 ,    . */
    schar fsdfile;          /* ecpop aa, 0, ec o oe e */
    int seekhigh;           /*    (   ):  */
    int seeklow;            /*                              :  */
    char fsdbytes;  /*    - ,  
			 ,    fsdnlines-1 :
			  :
			1-127       
			0          
			128+n   .    n*128+next 
				   .
			    fsdnlines-1 ,  
			  ,    
			,      fsd   
			 ,     
			   .               */
};

/*   -  fsdbyte */
struct fsdsht {
    struct fsd *backptr, *fwdptr;
    char    fsdnlines;
    schar   fsdfile;
    int     seekhigh, seeklow;
};
#define SFSD (sizeof (struct fsdsht))

struct fsd *openfsds[MAXFILES];

char *openfnames[MAXFILES];
char  openwrite [MAXFILES];     /* 1 -       */
char  movebak   [MAXFILES];     /* 1 -     .bak  */
int   nlines    [MAXFILES];     /*      */

/* workspace - ,    */
struct workspace {
    struct fsd *curfsd;             /* ptr   fsd                   */
    int     ulhclno;                /*  ,         */
    int     ulhccno;                /*  ,  0     */
    int     curlno;                 /*                    */
    int     curflno;                /*  ,   curfsd        */
    /*char    ws_flags; */              /*                        */
    int     wfile;                  /*  , 0 -        */
    int     ccol;                   /* curorcol,              */
    int     crow;                   /* cursorline,            */
    struct workspace *next_wksp;    /*  workspace             */
};
#define SWKSP       (sizeof (struct workspace))
#define ABS_LIN(l)  ((l)+curwksp->ulhclno)
#define ABS_COL(c)  ((c)+curwksp->ulhccno)
#define REL_LIN(l)  ((l)-curwksp->ulhclno)
#define REL_COL(c)  ((c)-curwksp->ulhccno)

struct workspace *curwksp, *pickwksp;

int curfile;

/*
 *      viewport -     
 *
 *     ,   ltext  ttext,   
 *   (0,0) =  .
 *   6      ltext  ttext.
 *
 *   ,    ,  *w,
 *        - *s
 */

struct viewport {
    struct workspace *wksp; /*   workspace                  */
    char prevport;          /*  .                      */
    schar flags;            /*  /                  */
    int ltext;              /*s    ( .  0,0)     */
    int rtext;              /*w                         */
    int ttext;              /*s                       */
    int btext;              /*w                           */
    int lmarg;              /*s   == ..text  +1       */
    int rmarg;              /*s , , ,       */
    int tmarg;              /*s                                     */
    int bmarg;              /*s                                     */
    int ledit;              /*w           */
    int redit;              /*w    .text: ,  */
    int tedit;              /*w                                     */
    int bedit;              /*w                                     */
    schar *firstcol;        /*   , !=' '         */
    schar *lastcol;         /*  -//-   -//-                */
    schar *lmchars;         /*  -           */
    schar *rmchars;         /*  -          */
};
#define SVIEWPORT (sizeof (struct viewport))

struct viewport
    *portlist[MAXPORTLIST+1],
    *curport,                   /*                       */
    *zoomedp,                   /* , .          */
     wholescreen,               /*                         */
     paramport,                 /*                 */
     zoomport;                  /*   - help  zoomfile   */

int nportlist;

/*    */
#define ZOOML       (NLINES - NPARAMLINES)
#define L_HELP      ZOOML
#define helpport    zoomport

/*
 *    
 * ROLL - 0 / , Y - , N - roll 
 */
#define WF_ROLL     03
#define WF_YROLL    01
#define WF_NROLL    02

/*
 *   drawport
 */
#define DRAW_HORI   0
#define DRAW_TABS   1
#define DRAW_ALL    2

/* savebuf - ,     */
struct savebuf {
    int linenum;    /*     "#"    */
    int nrows;      /*                    */
    int ncolumns;   /*                  */
};
#define SSAVEBUF (sizeof (struct savebuf))

struct savebuf *pickbuf, *deletebuf;


int cursorline;     /* physical screen position of cursor   */
int cursorcol;      /* from (0,0)=ulhc of text in port      */

/*char cntlmotions[];*/

# ifndef MAX_IARGS
# define MAX_IARGS  30
# endif

/* .     */
#define LKEYSTR 64

/*       */
#define SCALE long
#define LSCALE(l)   (((l) >> 5) + 1)
#define ISBIT(s,i)  (s[ (i) >> 5] &   (1l << ((i) & 037) ) )
#define SETBIT(s,i) (s[ (i) >> 5] |=  (1l << ((i) & 037) ) )
#define CLRBIT(s,i) (s[ (i) >> 5] &= ~(1l << ((i) & 037) ) )

# define MAXTCOL 640

SCALE tabstps[LSCALE(MAXTCOL)];

#define ISTAB(i)    ISBIT(tabstps,i)
#define SETTAB(i)   SETBIT(tabstps,i)
#define CLRTAB(i)   CLRBIT(tabstps,i)

int deftabstep;
int chg_tabs;
int showtabs;

#define B_MARG(col) (showtabs && col < MAXTCOL && ISTAB(col) ? BMTCH : BMCH)

char blanks[LINELM];

/*extern int readch();  */      /*   , -1 -  ! */
char intrflag;              /* 1 -   INTERUP */

/*  */
int
    defplline,
    defplpage,
    defmiline,
    defmipage,
    deflport,
    defrport,
    definsert,
    defdelete,
    defpick;

char *deffile;

int defreturn;

int errsw;          /* 1 -       */

/*
 *    param():
 * paraml -  ;
 * char *paramv -  ,
 * paramtype -  ,
 * paramc0, paramr0, paramc1 < paramr1 -
 *    "cursor defined"
 */
int paraml;
char *paramv;
int paramtype;
int paramc0, paramr0, paramc1, paramr1;

/*
 * cline 0 -   , lcline - . ,
 * ncline -  , icline  -   
 * fcline -  ( ), clineno -    
 */
char *cline;
int lcline;
int ncline;
int icline;
char fcline;
int clineno;
int clineexist;

char *KeyMode;

/*  ()    */
char *TTYnm ;
char *TTYtmp;
char *RFile ;
char *InitPath ;
char *HelpPath ;
char *RedKeys;

/*         */
char *MacroFile ;

/*     */
char *ttynm, *ttytmp, *rfile;

/*
 *  :
 * tempfile, tempfh, tempfl -  
 *    
 * ttyfile -   
 * inputfile -      
 */
int tempfile;
int tempfh;
int tempfl;
int ttyfile;
int inputfile;

/*
 * Oca  ac poooa
 */
#ifdef UN_CHAR
#define PUTP(c) put1w((short)c, ttyfile)
#define GETP(c,f) (c = get1w(f))
#else
#define PUTP(c) put1c((char)c, ttyfile) */
#define GETP(c,f) (c = get1c(f))
#endif

schar *ps_inmac;
char *searchkey;

int userid, groupid;

char *tmpname;          /* name of file, for do command */

/*     */
int LINEL, NLINES;      /* SIZE OF THE SCREEN  - VT.C   */
int eolflag;
char *curspos;
char **cvtout;
int video_mode;      /* 0 -  , 1 -   */
int cur_atr;         /*          */

#ifndef DEMOSES
char *(*agoto)();       /* for termcap definitions      */
int (*atcread)();
int slowsw;             /* is 1 if slow speed terminal  */
int lcasef, latf, flgtabs; /* terminal modes flags      */
int kioutf;             /*  0  15IE0013    */

#ifdef RED_CYRILL
int Rcyflag;
#endif

int on_scroll;      /* ,  roll           */
int fix_screen;     /*      */
int on_autoi;       /*   -       */
int autoindent;     /* Auto-indent                      */
#else   /* +DEMOSES */
int rawf, lcasef, latf, flgtabs, speccase; /* terminal modes flags */
#endif  /* DEMOSES */

int new_info;       /*  -  info      */
int need_box;       /*  -       */

#ifdef DEMOSES
int newedit;        /*  -        */
int dflinsert;
int silentflag;     /* He aa a epa          */
int werrflag;
#endif

char **next_args;    /*    */
int zoomflag;       /*  "zoom"     */

#include "S.tele.h"

/*
 *     
 * , . ,  
 */
int sel_flag;
int sel_lin, sel_col, sel_file;
struct workspace *sel_wspace;
int defedit;

/*
 * cmdstr -  
 */
struct cmdstr {
    short cmd_cmd;      /* 0 -   */
    short cmd_rep;      /*   */
    short cmd_ac;       /*   */
    short cmd_break;    /*  -    */
    char **cmd_av;      /*   */
};

#ifndef CEOF
#define CEOF  4
#endif  /* CEOF --    <termios.h> */

/*--   --*/
#include "r.defun.h"


